package tests;

import ssim.Event;
import ssim.Process;
import ssim.Sim;

public class twoprocesses extends junit.framework.TestCase
{
    public static class Client implements Process
    {
	private int m_iterations;
	private int m_interval;
	private String m_name;

	public Client( String n, int i, int delta)
	{
	    m_iterations = i;
	    m_interval = delta;
	    m_name = n;
	}

	public void init()
	{
	    System.out.println( "tests.twoprocesses.Client.init() called" );
	    Sim.set_timeout( 0 );
	}

	public void process_event( Event event )
	{
	    System.out.println( "tests.twoprocesses.Client.process_event() called" );
	}

	public void process_timeout()
	{
	    System.out.print( "I am " + m_name + ", the time is " + Sim.clock() );
	    if( m_iterations > 0 ) {
		System.out.print( ", " + m_iterations + " to go!" );
		--m_iterations;
		Sim.set_timeout( m_interval );
	    }
	    else {
		System.out.print( ", no more iterations.  Bye!" );
	    }
	    System.out.println();
	}

	public void stop()
	{
	    System.out.println( "tests.twoprocesses.Client.stop() called" );
	}
    }

    public twoprocesses( String name )
    {
	super( name );
    }

    public void test()
    {
	Client c1 = new Client( "Yan Yan", 10, 100 );
	Client c2 = new Client( "Antonio", 30, 50 );

	Sim.create_process( c1 );
	Sim.create_process( c2 );
	
	Sim.run_simulation();
    }
}


